# opentl::modalities::Motion Class Reference

Inherits opentl::modalities::Modality.

List of all members.

## Public Types
## Public Member Functions
virtual modalities::Modality * | clone () const
| Creates an additional copy of this class instance.
void | init ()
| Initialization function.
virtual int | matchPixLevel (const TargetPtrVector &targets, T_MEAS_PIXPtrVector &outputMeas, std::size_t partitionIdx)
| Matching on pixel level compare pixel-level image data with expected map, by projecting model data under a predicted state.
| Motion (const Motion &c)
| Copy Constructor (deep copy).
| Motion (opentl::modelprojection::Warp *warp, int camIdx)
| Constructor.
virtual int | preProcess (const opentl::core::cvdata::Image &image, const std::vector< std::vector< int > > &preProcessROIs)
| Update motion history image (MHI).
virtual | ~Motion ()
| Destructor.
## Protected Attributes
int | mHeight
opentl::cvprocess::MotionSegment * | motionSegment
int | mWidth
std::size_t | nSensors

## Member Enumeration Documentation

enum opentl::modalities::Motion::OfflineParameters

Parameters for visual processing in this class.

Enumerator:

  matchPixelRInvVariance | (double) matchPixelRInvVariance

Reimplemented from opentl::modalities::Modality.

enum opentl::modalities::Motion::OnlineParameters

Reimplemented from opentl::modalities::Modality.

## Constructor & Destructor Documentation

opentl::modalities::Motion::Motion | ( | opentl::modelprojection::Warp * | warp,
|  | int | camIdx |
| ) |  |  |

Constructor.

Parameters:

  | warp |
  | cam | index

opentl::modalities::Motion::Motion | ( | const Motion & | c | ) |

Copy Constructor (deep copy).

virtual opentl::modalities::Motion::~Motion | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

virtual modalities::Modality* opentl::modalities::Motion::clone | ( |  | ) | const`[virtual]`

Creates an additional copy of this class instance.

Implements opentl::modalities::Modality.

void opentl::modalities::Motion::init | ( |  | ) | `[virtual]`

Initialization function.

Reimplemented from opentl::modalities::Modality.

virtual int opentl::modalities::Motion::matchPixLevel | ( | const TargetPtrVector & | targets,
|  | T_MEAS_PIXPtrVector & | outputMeas,
|  | std::size_t | partitionIdx |
| ) |  |  | `[virtual]`

Matching on pixel level

- compare pixel-level image data with expected map, by projecting model data under a predicted state.

Parameters:

  | target | vector
  | outputMeas | Pixel-space measurement (can be a pixel map of residuals, or a unique residual value)
  | partition | index

Reimplemented from opentl::modalities::Modality.

virtual int opentl::modalities::Motion::preProcess | ( | const opentl::core::cvdata::Image & | image,
|  | const std::vector< std::vector< int > > & | preProcessROIs |
| ) |  |  | `[virtual]`

Update motion history image (MHI).

Parameters:

  | image | Input sensor data (e.g. camera image in RGB)
  | preProcessROIs | Regions of interest (x0,y0,width,height), per target

Reimplemented from opentl::modalities::Modality.

## Member Data Documentation

int opentl::modalities::Motion::mHeight`[protected]`

opentl::cvprocess::MotionSegment* opentl::modalities::Motion::motionSegment`[protected]`

brief Motion Segmentation

int opentl::modalities::Motion::mWidth`[protected]`

std::size_t opentl::modalities::Motion::nSensors`[protected]`